searchData={"items":[{"type":"module","title":"Vik","doc":"The public API all Shards have access to; imported\nby default.","ref":"Vik.html"},{"type":"type","title":"Vik.export/0","doc":"","ref":"Vik.html#t:export/0"},{"type":"macro","title":"Vik.export/1","doc":"Can be used to make modules available to other shards\nusing `include/1`.","ref":"Vik.html#export/1"},{"type":"macro","title":"Examples - Vik.export/1","doc":"defmodule Hello do\n      def world do\n        \"hewwo world :3\"\n      end\n    end\n\n    export Hello","ref":"Vik.html#export/1-examples"},{"type":"macro","title":"Vik.expose/1","doc":"Exposes the given function or module as a publicly\naccessible API endpoint.","ref":"Vik.html#expose/1"},{"type":"macro","title":"Examples - Vik.expose/1","doc":"def call(conn, []) do\n      send_resp(conn, 200, \"hewwo world :3\")\n    end\n\n    expose call: 2\n\n\n    def call(conn, ~m{name}s, []) do\n      send_resp(conn, 200, \"hewwo, #{name}!)\n    end\n\n    expose call: 3","ref":"Vik.html#expose/1-examples"},{"type":"macro","title":"Vik.include/1","doc":"Can be used to automatically alias modules\ndefined by another shard in the current shard.\n\nThe other module will be compiled before the\ncalling module. Cyclic dependencies will crash\nthe system. So maybe don't do that? thx :)","ref":"Vik.html#include/1"},{"type":"macro","title":"Examples - Vik.include/1","doc":"include \"foo\"\n    Foo.bar()","ref":"Vik.html#include/1-examples"},{"type":"type","title":"Vik.slug/0","doc":"","ref":"Vik.html#t:slug/0"},{"type":"module","title":"Vik.Logger","doc":"Simple logging server.\n\nThe server holds a list of all log entries in memory;\nthis comprises all exceptions and related messages\nemitted since application boot.\n\nThis server pushes messages to the default webhook configured\nvia the `DEFAULT_WEBHOOK` environment variable. An additional\nlogger-specific webhook is supported to.\n\nTo utilize this functionality, export the `LOGGER_WEBHOOK`\nvariable in your system's environment:\n\n    export LOGGER_WEBHOOK=\"https://discord.com/api/webhooks/...\"\n\nThe webhook will also receive messages in the following JSON\nstructured format (as defined by `t:Vik.Webhook.payload/0`):\n\n    {\"event\": \"logger.message\", \"content\": \"** (RuntimeError) hewwo world :3\"}","ref":"Vik.Logger.html"},{"type":"function","title":"Vik.Logger.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Vik.Logger.html#child_spec/1"},{"type":"function","title":"Vik.Logger.clear/1","doc":"Delete `n` oldest log entries.","ref":"Vik.Logger.html#clear/1"},{"type":"function","title":"Vik.Logger.exception/2","doc":"Logs an exception.\n\nExcludes all stacktraces unrelated to user code.\n(Everything outside the `Vik.UserShard` namespace.)","ref":"Vik.Logger.html#exception/2"},{"type":"function","title":"Vik.Logger.info/1","doc":"Logs a simple message.","ref":"Vik.Logger.html#info/1"},{"type":"function","title":"Vik.Logger.start_link/1","doc":"Starts the server.","ref":"Vik.Logger.html#start_link/1"},{"type":"function","title":"Vik.Logger.subscribe/0","doc":"Subscribes to log entries via PubSub.","ref":"Vik.Logger.html#subscribe/0"},{"type":"function","title":"Examples - Vik.Logger.subscribe/0","doc":"@initial_lines 50\n\n    def mount(_, _, socket) do\n      Vik.Logger.subscribe()\n\n      lines = Vik.Logger.tail(@initial_lines)\n      {:ok, stream(socket, :logs, lines)}\n    end\n\n    def handle_info({:lines, lines}, socket) do\n      {:noreply, stream(socket, :logs, lines, at: 0)}\n    end","ref":"Vik.Logger.html#subscribe/0-examples"},{"type":"function","title":"Vik.Logger.tail/1","doc":"Returns `n` latest log entries.","ref":"Vik.Logger.html#tail/1"},{"type":"module","title":"Vik.Repo","doc":"","ref":"Vik.Repo.html"},{"type":"function","title":"Vik.Repo.aggregate/3","doc":"","ref":"Vik.Repo.html#aggregate/3"},{"type":"function","title":"Vik.Repo.aggregate/4","doc":"","ref":"Vik.Repo.html#aggregate/4"},{"type":"function","title":"Vik.Repo.all/2","doc":"","ref":"Vik.Repo.html#all/2"},{"type":"function","title":"Vik.Repo.checked_out?/0","doc":"","ref":"Vik.Repo.html#checked_out?/0"},{"type":"function","title":"Vik.Repo.checkout/2","doc":"","ref":"Vik.Repo.html#checkout/2"},{"type":"function","title":"Vik.Repo.child_spec/1","doc":"","ref":"Vik.Repo.html#child_spec/1"},{"type":"function","title":"Vik.Repo.config/0","doc":"","ref":"Vik.Repo.html#config/0"},{"type":"function","title":"Vik.Repo.default_options/1","doc":"","ref":"Vik.Repo.html#default_options/1"},{"type":"function","title":"Vik.Repo.delete/2","doc":"","ref":"Vik.Repo.html#delete/2"},{"type":"function","title":"Vik.Repo.delete!/2","doc":"","ref":"Vik.Repo.html#delete!/2"},{"type":"function","title":"Vik.Repo.delete_all/2","doc":"","ref":"Vik.Repo.html#delete_all/2"},{"type":"function","title":"Vik.Repo.delete_by!/2","doc":"Deletes a struct using an arbitrary query.\n\nSee `get_by!/2` and `delete!/2`.","ref":"Vik.Repo.html#delete_by!/2"},{"type":"function","title":"Vik.Repo.disconnect_all/2","doc":"A convenience function for SQL-based repositories that forces all connections in the\npool to disconnect within the given interval.\n\nSee `Ecto.Adapters.SQL.disconnect_all/3` for more information.","ref":"Vik.Repo.html#disconnect_all/2"},{"type":"function","title":"Vik.Repo.exists?/2","doc":"","ref":"Vik.Repo.html#exists?/2"},{"type":"function","title":"Vik.Repo.explain/3","doc":"A convenience function for SQL-based repositories that executes an EXPLAIN statement or similar\ndepending on the adapter to obtain statistics for the given query.\n\nSee `Ecto.Adapters.SQL.explain/4` for more information.","ref":"Vik.Repo.html#explain/3"},{"type":"function","title":"Vik.Repo.get/3","doc":"","ref":"Vik.Repo.html#get/3"},{"type":"function","title":"Vik.Repo.get!/3","doc":"","ref":"Vik.Repo.html#get!/3"},{"type":"function","title":"Vik.Repo.get_by/3","doc":"","ref":"Vik.Repo.html#get_by/3"},{"type":"function","title":"Vik.Repo.get_by!/3","doc":"","ref":"Vik.Repo.html#get_by!/3"},{"type":"function","title":"Vik.Repo.get_dynamic_repo/0","doc":"","ref":"Vik.Repo.html#get_dynamic_repo/0"},{"type":"function","title":"Vik.Repo.in_transaction?/0","doc":"","ref":"Vik.Repo.html#in_transaction?/0"},{"type":"function","title":"Vik.Repo.insert/2","doc":"","ref":"Vik.Repo.html#insert/2"},{"type":"function","title":"Vik.Repo.insert!/2","doc":"","ref":"Vik.Repo.html#insert!/2"},{"type":"function","title":"Vik.Repo.insert_all/3","doc":"","ref":"Vik.Repo.html#insert_all/3"},{"type":"function","title":"Vik.Repo.insert_or_update/2","doc":"","ref":"Vik.Repo.html#insert_or_update/2"},{"type":"function","title":"Vik.Repo.insert_or_update!/2","doc":"","ref":"Vik.Repo.html#insert_or_update!/2"},{"type":"function","title":"Vik.Repo.load/2","doc":"","ref":"Vik.Repo.html#load/2"},{"type":"function","title":"Vik.Repo.one/2","doc":"","ref":"Vik.Repo.html#one/2"},{"type":"function","title":"Vik.Repo.one!/2","doc":"","ref":"Vik.Repo.html#one!/2"},{"type":"function","title":"Vik.Repo.preload/3","doc":"","ref":"Vik.Repo.html#preload/3"},{"type":"function","title":"Vik.Repo.prepare_query/3","doc":"","ref":"Vik.Repo.html#prepare_query/3"},{"type":"function","title":"Vik.Repo.put_dynamic_repo/1","doc":"","ref":"Vik.Repo.html#put_dynamic_repo/1"},{"type":"function","title":"Vik.Repo.query/3","doc":"A convenience function for SQL-based repositories that executes the given query.\n\nSee `Ecto.Adapters.SQL.query/4` for more information.","ref":"Vik.Repo.html#query/3"},{"type":"function","title":"Vik.Repo.query!/3","doc":"A convenience function for SQL-based repositories that executes the given query.\n\nSee `Ecto.Adapters.SQL.query!/4` for more information.","ref":"Vik.Repo.html#query!/3"},{"type":"function","title":"Vik.Repo.query_many/3","doc":"A convenience function for SQL-based repositories that executes the given multi-result query.\n\nSee `Ecto.Adapters.SQL.query_many/4` for more information.","ref":"Vik.Repo.html#query_many/3"},{"type":"function","title":"Vik.Repo.query_many!/3","doc":"A convenience function for SQL-based repositories that executes the given multi-result query.\n\nSee `Ecto.Adapters.SQL.query_many!/4` for more information.","ref":"Vik.Repo.html#query_many!/3"},{"type":"function","title":"Vik.Repo.reload/2","doc":"","ref":"Vik.Repo.html#reload/2"},{"type":"function","title":"Vik.Repo.reload!/2","doc":"","ref":"Vik.Repo.html#reload!/2"},{"type":"function","title":"Vik.Repo.rollback/1","doc":"","ref":"Vik.Repo.html#rollback/1"},{"type":"function","title":"Vik.Repo.start_link/1","doc":"","ref":"Vik.Repo.html#start_link/1"},{"type":"function","title":"Vik.Repo.stop/1","doc":"","ref":"Vik.Repo.html#stop/1"},{"type":"function","title":"Vik.Repo.stream/2","doc":"","ref":"Vik.Repo.html#stream/2"},{"type":"function","title":"Vik.Repo.to_sql/2","doc":"A convenience function for SQL-based repositories that translates the given query to SQL.\n\nSee `Ecto.Adapters.SQL.to_sql/3` for more information.","ref":"Vik.Repo.html#to_sql/2"},{"type":"function","title":"Vik.Repo.transaction/2","doc":"","ref":"Vik.Repo.html#transaction/2"},{"type":"function","title":"Vik.Repo.update/2","doc":"","ref":"Vik.Repo.html#update/2"},{"type":"function","title":"Vik.Repo.update!/2","doc":"","ref":"Vik.Repo.html#update!/2"},{"type":"function","title":"Vik.Repo.update_all/3","doc":"","ref":"Vik.Repo.html#update_all/3"},{"type":"module","title":"Vik.System","doc":"Fetches and formats system information.","ref":"Vik.System.html"},{"type":"function","title":"Vik.System.fetch_system_info/2","doc":"Fetches system info (version, specs, limits etc.) for\nthe given `node`.\n\nIf provided, will fetch values for the given `keys` from\nthe shell environment.","ref":"Vik.System.html#fetch_system_info/2"},{"type":"function","title":"Vik.System.fetch_system_usage/1","doc":"Fetches current system usage statistics for the given node.","ref":"Vik.System.html#fetch_system_usage/1"},{"type":"function","title":"Vik.System.nodes/0","doc":"All connected nodes (including the current node).","ref":"Vik.System.html#nodes/0"},{"type":"module","title":"Vik.Webhook","doc":"Handler for integrating Vik into 3rd-party software\nusing (optional) webhooks.","ref":"Vik.Webhook.html"},{"type":"module","title":"Usage - Vik.Webhook","doc":"To utilize this functionality, export the `DEFAULT_WEBHOOK`\nvariable in your system's environment:\n\n    export DEFAULT_WEBHOOK=\"https://discord.com/api/webhooks/...\"","ref":"Vik.Webhook.html#module-usage"},{"type":"module","title":"Available webhooks - Vik.Webhook","doc":"- `DEFAULT_WEBHOOK` receives messages for *all* events.\n- `LOGGER_WEBHOOK` receives only `logger.message` events.\n- `SCRY_WEBHOOK` receives only `shard.save` events.","ref":"Vik.Webhook.html#module-available-webhooks"},{"type":"type","title":"Vik.Webhook.event/0","doc":"Implemented events:\n\n  - `shard.save`\n  - `shard.deploy`\n  - `logger.message`","ref":"Vik.Webhook.html#t:event/0"},{"type":"type","title":"Vik.Webhook.payload/0","doc":"Payload sent to the configured endpoint.","ref":"Vik.Webhook.html#t:payload/0"},{"type":"function","title":"Vik.Webhook.push/2","doc":"Sends a message to a user-defined webhook.\n\nThe configured endpoint receives JSON data, as defined\nby `t:payload/0`:\n\n    {\"event\": \"shard.save\", \"content\": ... }","ref":"Vik.Webhook.html#push/2"},{"type":"module","title":"KV","doc":"A modular key-value store for arbitrary, \ndisk-persisted term storage based on `:dets`.","ref":"KV.html"},{"type":"module","title":"Usage - KV","doc":"Add `KV` to your supervision tree:\n\n    {KV, root: \"/tmp\"}","ref":"KV.html#module-usage"},{"type":"function","title":"KV.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"KV.html#child_spec/1"},{"type":"function","title":"KV.clear/1","doc":"Deletes all objects from the given `table`, effectively\nemptying it.","ref":"KV.html#clear/1"},{"type":"function","title":"Examples - KV.clear/1","doc":"iex> KV.list(:users)\n    [%User{id: 1, name: \"Robin\", age: 18}, %User{id: 2, name: \"Gijs\", age: 15}]\n\n    iex> KV.clear(:users)\n    iex> KV.list(:users)\n    []","ref":"KV.html#clear/1-examples"},{"type":"function","title":"KV.delete/2","doc":"Deletes the object for the given `key` from `table`.","ref":"KV.html#delete/2"},{"type":"function","title":"Examples - KV.delete/2","doc":"iex> KV.put(:users, 1, %User{id: 1, name: \"Robin\", age: 18})\n    iex> KV.get(:users, 1)\n    %User{id: 1, name: \"Robin\", age: 18}\n\n    iex> KV.delete(:users, 1)\n    iex> KV.get(:users, 1)\n    nil","ref":"KV.html#delete/2-examples"},{"type":"function","title":"KV.fetch/2","doc":"Gets the object for the given `key` from `table`.","ref":"KV.html#fetch/2"},{"type":"function","title":"Examples - KV.fetch/2","doc":"iex> KV.get(:users, 1)\n    {:ok, %User{id: 1, name: \"Robin\", age: 18}}\n\n    iex> KV.get(:users, 3)\n    :error\n\n    iex> KV.get(:non_existant, 3)\n    :error","ref":"KV.html#fetch/2-examples"},{"type":"function","title":"KV.get/2","doc":"Same as `fetch/2`, but returns `nil` if the given table \nor key cannot be found.","ref":"KV.html#get/2"},{"type":"function","title":"Examples - KV.get/2","doc":"iex> KV.get(:users, 1)\n    %User{id: 1, name: \"Robin\", age: 18}\n\n    iex> KV.get(:users, 3)\n    nil\n\n    iex> KV.get(:non_existant, 3)\n    nil","ref":"KV.html#get/2-examples"},{"type":"type","title":"KV.key/0","doc":"","ref":"KV.html#t:key/0"},{"type":"function","title":"KV.list/1","doc":"Lists all objects in the given `table`.","ref":"KV.html#list/1"},{"type":"function","title":"Examples - KV.list/1","doc":"iex> KV.list(:users)\n    [%User{id: 1, name: \"Robin\", age: 18}, %User{id: 2, name: \"Gijs\", age: 15}]","ref":"KV.html#list/1-examples"},{"type":"type","title":"KV.object/0","doc":"","ref":"KV.html#t:object/0"},{"type":"function","title":"KV.put/3","doc":"Puts the given `object` in `table`.\n\nIf the table does not exist yet, it is created on-demand.","ref":"KV.html#put/3"},{"type":"function","title":"Examples - KV.put/3","doc":"iex> KV.put(:users, 1, %User{id: 1, name: \"Robin\", age: 18})\n    iex> KV.put(:users, 2, %User{id: 2, name: \"Gijs\", age: 15})\n    :ok","ref":"KV.html#put/3-examples"},{"type":"function","title":"KV.start_link/1","doc":"Starts the store.","ref":"KV.html#start_link/1"},{"type":"type","title":"KV.start_opts/0","doc":"","ref":"KV.html#t:start_opts/0"},{"type":"type","title":"KV.table/0","doc":"","ref":"KV.html#t:table/0"},{"type":"module","title":"Vik.Compiler","doc":"Compiles the Shards into actual Elixir modules living\nin the Erlang VM.","ref":"Vik.Compiler.html"},{"type":"function","title":"Vik.Compiler.eval/1","doc":"Compiles the given `Vik.Shard`.\n\nReturns the resulting module and any exports.","ref":"Vik.Compiler.html#eval/1"},{"type":"function","title":"Vik.Compiler.eval!/1","doc":"Same as `eval/1`, but raises if something crashes\nduring compilation.","ref":"Vik.Compiler.html#eval!/1"},{"type":"function","title":"Vik.Compiler.extract_exports/1","doc":"Extracts the list of module names that the given\n`Vik.Shard` exports.","ref":"Vik.Compiler.html#extract_exports/1"},{"type":"function","title":"Vik.Compiler.extract_includes/1","doc":"Extracts a list of slugs for the shards that\nthe given `Vik.Shard` depends on.","ref":"Vik.Compiler.html#extract_includes/1"},{"type":"function","title":"Vik.Compiler.module_name/1","doc":"Generates a module name from a unique slug.","ref":"Vik.Compiler.html#module_name/1"},{"type":"type","title":"Vik.Compiler.quoted/0","doc":"","ref":"Vik.Compiler.html#t:quoted/0"},{"type":"type","title":"Vik.Compiler.slug/0","doc":"","ref":"Vik.Compiler.html#t:slug/0"},{"type":"type","title":"Vik.Compiler.source/0","doc":"","ref":"Vik.Compiler.html#t:source/0"},{"type":"module","title":"Vik.Result","doc":"Structural representation of a compiled `Vik.Shard`.\nHolds metadata regarding compile-dependencies, along\nwith the compilation result.\n\nThe `stale?` flag indicates that a newer version of\nthe module exists in the database but failed to compile.\n\nThis data is recorded in the `Vik.Store`.","ref":"Vik.Result.html"},{"type":"function","title":"Vik.Result.new/3","doc":"","ref":"Vik.Result.html#new/3"},{"type":"function","title":"Vik.Result.put_stale/2","doc":"","ref":"Vik.Result.html#put_stale/2"},{"type":"type","title":"Vik.Result.t/0","doc":"","ref":"Vik.Result.html#t:t/0"},{"type":"module","title":"Vik.Shard","doc":"Shards are the building blocks of `Vik`. They are standalone\nsnippets of code that are compiled into Elixir modules.\n\nThey can define compile-time dependencies on other shards.","ref":"Vik.Shard.html"},{"type":"function","title":"Vik.Shard.new_changeset/1","doc":"","ref":"Vik.Shard.html#new_changeset/1"},{"type":"function","title":"Vik.Shard.save_changeset/2","doc":"","ref":"Vik.Shard.html#save_changeset/2"},{"type":"type","title":"Vik.Shard.t/0","doc":"","ref":"Vik.Shard.html#t:t/0"},{"type":"module","title":"Vik.Store","doc":"The Store is a key-value store that holds the compile\nresults (`Vik.Result`) by slug.","ref":"Vik.Store.html"},{"type":"function","title":"Vik.Store.fetch/1","doc":"","ref":"Vik.Store.html#fetch/1"},{"type":"function","title":"Vik.Store.fetch!/1","doc":"","ref":"Vik.Store.html#fetch!/1"},{"type":"function","title":"Vik.Store.get/1","doc":"","ref":"Vik.Store.html#get/1"},{"type":"function","title":"Vik.Store.mark_stale/1","doc":"","ref":"Vik.Store.html#mark_stale/1"},{"type":"function","title":"Vik.Store.put/2","doc":"","ref":"Vik.Store.html#put/2"},{"type":"type","title":"Vik.Store.state/0","doc":"","ref":"Vik.Store.html#t:state/0"},{"type":"type","title":"Vik.Store.status/0","doc":"","ref":"Vik.Store.html#t:status/0"},{"type":"function","title":"Vik.Store.status/1","doc":"","ref":"Vik.Store.html#status/1"},{"type":"module","title":"Vik.Thread","doc":"Manages compilation and side-effects.\n\n- Communicates with the LiveViews over PubSub to\n  report on compiler logs, stale Shards etc.\n\n- Ensures the `Vik.Store` is properly populated with the\n  results produced by the `Vik.Compiler`.","ref":"Vik.Thread.html"},{"type":"function","title":"Vik.Thread.ensure_compiled!/1","doc":"","ref":"Vik.Thread.html#ensure_compiled!/1"},{"type":"function","title":"Vik.Thread.eval/1","doc":"","ref":"Vik.Thread.html#eval/1"},{"type":"function","title":"Vik.Thread.eval!/1","doc":"","ref":"Vik.Thread.html#eval!/1"},{"type":"function","title":"Vik.Thread.mark_stale/1","doc":"","ref":"Vik.Thread.html#mark_stale/1"},{"type":"function","title":"Vik.Thread.provision/1","doc":"","ref":"Vik.Thread.html#provision/1"},{"type":"module","title":"Vik.Authority","doc":"Acts as the central authority for active `@codemirror/collab`\nsessions. Holds the authoritative master copy of every shard.\n\nThis enables real-time collaborative editing across multiple\nbrowser windows or devices.","ref":"Vik.Authority.html"},{"type":"function","title":"Vik.Authority.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Vik.Authority.html#child_spec/1"},{"type":"function","title":"Vik.Authority.fetch_changes/2","doc":"Pulls any changes made since `version`.","ref":"Vik.Authority.html#fetch_changes/2"},{"type":"function","title":"Vik.Authority.get_document/1","doc":"Returns the session with all relevant data for\nconstructing the current CodeMirror document.","ref":"Vik.Authority.html#get_document/1"},{"type":"function","title":"Vik.Authority.join/2","doc":"Joins a collaboration session.\n\nIf not initialised yet, this will create a new session.\nWhen empty, the collaboration session will automatically close.","ref":"Vik.Authority.html#join/2"},{"type":"function","title":"Vik.Authority.push_changes/3","doc":"Pushes new changes starting from `version`.","ref":"Vik.Authority.html#push_changes/3"},{"type":"function","title":"Vik.Authority.start_link/1","doc":"Starts the authority.","ref":"Vik.Authority.html#start_link/1"},{"type":"opaque","title":"Vik.Authority.state/0","doc":"","ref":"Vik.Authority.html#t:state/0"},{"type":"type","title":"Vik.Authority.suid/0","doc":"Session identifiers uniquely identify a collaborative\nsession.\n\nFor convience, Shard slugs double as valid session \nidentifiers as well.","ref":"Vik.Authority.html#t:suid/0"},{"type":"type","title":"Vik.Authority.uid/0","doc":"User identifiers uniquely identify every participant in\na collaborative session.","ref":"Vik.Authority.html#t:uid/0"},{"type":"type","title":"Vik.Authority.version/0","doc":"","ref":"Vik.Authority.html#t:version/0"},{"type":"module","title":"Vik.Authority.Session","doc":"Structural representation of a collaborative session.\n\nHolds metadata regarding the number of active participants,\nthe source code of the original document, updates since\nand the version of the latest rendition of the document.","ref":"Vik.Authority.Session.html"},{"type":"type","title":"Vik.Authority.Session.t/0","doc":"","ref":"Vik.Authority.Session.html#t:t/0"},{"type":"module","title":"Vik.Authority.Update","doc":"JSON payload consisting of changes to a CodeMirror document. \nThe contents of these updates is seen as irrelevant to the \nauthority.\n\nThe `Vik.Authority` simply passes them along to the \nconcerning CodeMirror instances for further processing.","ref":"Vik.Authority.Update.html"},{"type":"type","title":"Vik.Authority.Update.t/0","doc":"","ref":"Vik.Authority.Update.html#t:t/0"},{"type":"module","title":"Vik.Presence","doc":"Enables live awareness features in collaborative contexts.","ref":"Vik.Presence.html"},{"type":"function","title":"Vik.Presence.child_spec/1","doc":"","ref":"Vik.Presence.html#child_spec/1"},{"type":"function","title":"Vik.Presence.count_participants/1","doc":"Counts the amount of active participants in a session.","ref":"Vik.Presence.html#count_participants/1"},{"type":"function","title":"Vik.Presence.fetchers_pids/0","doc":"","ref":"Vik.Presence.html#fetchers_pids/0"},{"type":"function","title":"Vik.Presence.get_by_key/2","doc":"","ref":"Vik.Presence.html#get_by_key/2"},{"type":"function","title":"Vik.Presence.list/1","doc":"","ref":"Vik.Presence.html#list/1"},{"type":"function","title":"Vik.Presence.list_participants/1","doc":"Returns a list of all active participants in a session.","ref":"Vik.Presence.html#list_participants/1"},{"type":"function","title":"Vik.Presence.subscribe/1","doc":"Subscribes to room join/leaves.","ref":"Vik.Presence.html#subscribe/1"},{"type":"function","title":"Message format - Vik.Presence.subscribe/1","doc":"- `{:join, suid, ~m{id, name, metas}}`\n- `{:leave, suid, ~m{id, name, metas}}`","ref":"Vik.Presence.html#subscribe/1-message-format"},{"type":"function","title":"Vik.Presence.track/3","doc":"","ref":"Vik.Presence.html#track/3"},{"type":"function","title":"Vik.Presence.track/4","doc":"","ref":"Vik.Presence.html#track/4"},{"type":"function","title":"Vik.Presence.unsubscribe/1","doc":"Unsubscribes from room join/leaves.","ref":"Vik.Presence.html#unsubscribe/1"},{"type":"function","title":"Vik.Presence.untrack/2","doc":"","ref":"Vik.Presence.html#untrack/2"},{"type":"function","title":"Vik.Presence.untrack/3","doc":"","ref":"Vik.Presence.html#untrack/3"},{"type":"function","title":"Vik.Presence.update/3","doc":"","ref":"Vik.Presence.html#update/3"},{"type":"function","title":"Vik.Presence.update/4","doc":"","ref":"Vik.Presence.html#update/4"},{"type":"module","title":"VikWeb","doc":"The entrypoint for defining your web interface, such\nas controllers, components, channels, and so on.\n\nThis can be used in your application as:\n\n    use VikWeb, :controller\n    use VikWeb, :html\n\nThe definitions below will be executed for every controller,\ncomponent, etc, so keep them short and clean, focused\non imports, uses and aliases.\n\nDo NOT define functions inside the quoted expressions\nbelow. Instead, define additional modules and import\nthose modules here.","ref":"VikWeb.html"},{"type":"macro","title":"VikWeb.__using__/1","doc":"When used, dispatch to the appropriate controller/live_view/etc.","ref":"VikWeb.html#__using__/1"},{"type":"function","title":"VikWeb.channel/0","doc":"","ref":"VikWeb.html#channel/0"},{"type":"function","title":"VikWeb.controller/0","doc":"","ref":"VikWeb.html#controller/0"},{"type":"function","title":"VikWeb.html/0","doc":"","ref":"VikWeb.html#html/0"},{"type":"function","title":"VikWeb.live_component/0","doc":"","ref":"VikWeb.html#live_component/0"},{"type":"function","title":"VikWeb.live_hook/0","doc":"","ref":"VikWeb.html#live_hook/0"},{"type":"function","title":"VikWeb.live_view/0","doc":"","ref":"VikWeb.html#live_view/0"},{"type":"function","title":"VikWeb.plug/0","doc":"","ref":"VikWeb.html#plug/0"},{"type":"function","title":"VikWeb.router/0","doc":"","ref":"VikWeb.html#router/0"},{"type":"function","title":"VikWeb.static_paths/0","doc":"","ref":"VikWeb.html#static_paths/0"},{"type":"function","title":"VikWeb.stream_color/4","doc":"","ref":"VikWeb.html#stream_color/4"},{"type":"function","title":"VikWeb.stream_lines/3","doc":"","ref":"VikWeb.html#stream_lines/3"},{"type":"function","title":"VikWeb.verified_routes/0","doc":"","ref":"VikWeb.html#verified_routes/0"},{"type":"module","title":"VikWeb.CodeMirror","doc":"Fully-fledged CodeMirror editor with support for\noptional collaborative editing.","ref":"VikWeb.CodeMirror.html"},{"type":"function","title":"VikWeb.CodeMirror.codemirror/1","doc":"Renders a CodeMirror instance as a drop-in replacement\nfor a HTML textarea.\n\nThis component provides feature-parity with\n`CoreComponents.input/1`.","ref":"VikWeb.CodeMirror.html#codemirror/1"},{"type":"function","title":"Attributes - VikWeb.CodeMirror.codemirror/1","doc":"* `id` (`:string`)\n* `name` (`:string`)\n* `value` (`:string`)\n* `field` (`Phoenix.FormField`)\n* `suid` (`:string`) - Defaults to `nil`.\n* `uid` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted.","ref":"VikWeb.CodeMirror.html#codemirror/1-attributes"},{"type":"function","title":"VikWeb.CodeMirror.sync/2","doc":"Applies the provided `Vik.Authority.Update`s to\nthe CodeMirror instance with the given ID.","ref":"VikWeb.CodeMirror.html#sync/2"},{"type":"module","title":"VikWeb.CoreComponents","doc":"Provides core UI components.\n\nAt first glance, this module may seem daunting, but its goal is to provide\ncore building blocks for your application, such as modals, tables, and\nforms. The components consist mostly of markup and are well-documented\nwith doc strings and declarative assigns. You may customize and style\nthem in any way you want, based on your application growth and needs.\n\nThe default components use Tailwind CSS, a utility-first CSS framework.\nSee the [Tailwind CSS documentation](https://tailwindcss.com) to learn\nhow to customize them or feel free to swap in another framework altogether.\n\nIcons are provided by [heroicons](https://heroicons.com). See `icon/1` for usage.","ref":"VikWeb.CoreComponents.html"},{"type":"function","title":"VikWeb.CoreComponents.back/1","doc":"Renders a back navigation link.","ref":"VikWeb.CoreComponents.html#back/1"},{"type":"function","title":"Examples - VikWeb.CoreComponents.back/1","doc":"<.back navigate={~p\"/posts\"}>Back to posts</.back>","ref":"VikWeb.CoreComponents.html#back/1-examples"},{"type":"function","title":"Attributes - VikWeb.CoreComponents.back/1","doc":"* `navigate` (`:any`) (required)","ref":"VikWeb.CoreComponents.html#back/1-attributes"},{"type":"function","title":"Slots - VikWeb.CoreComponents.back/1","doc":"* `inner_block` (required)","ref":"VikWeb.CoreComponents.html#back/1-slots"},{"type":"function","title":"VikWeb.CoreComponents.button/1","doc":"Renders a button.","ref":"VikWeb.CoreComponents.html#button/1"},{"type":"function","title":"Examples - VikWeb.CoreComponents.button/1","doc":"<.button>Send!</.button>\n    <.button phx-click=\"go\" class=\"ml-2\">Send!</.button>","ref":"VikWeb.CoreComponents.html#button/1-examples"},{"type":"function","title":"Attributes - VikWeb.CoreComponents.button/1","doc":"* `type` (`:string`) - Defaults to `nil`.\n* `class` (`:string`) - Defaults to `nil`.\n* Global attributes are accepted. Supports all globals plus: `[\"disabled\", \"form\", \"name\", \"value\"]`.","ref":"VikWeb.CoreComponents.html#button/1-attributes"},{"type":"function","title":"Slots - VikWeb.CoreComponents.button/1","doc":"* `inner_block` (required)","ref":"VikWeb.CoreComponents.html#button/1-slots"},{"type":"function","title":"VikWeb.CoreComponents.error/1","doc":"Generates a generic error message.","ref":"VikWeb.CoreComponents.html#error/1"},{"type":"function","title":"Slots - VikWeb.CoreComponents.error/1","doc":"* `inner_block` (required)","ref":"VikWeb.CoreComponents.html#error/1-slots"},{"type":"function","title":"VikWeb.CoreComponents.flash/1","doc":"Renders flash notices.","ref":"VikWeb.CoreComponents.html#flash/1"},{"type":"function","title":"Examples - VikWeb.CoreComponents.flash/1","doc":"<.flash kind={:info} flash={@flash} />\n    <.flash kind={:info} phx-mounted={show(\"#flash\")}>Welcome Back!</.flash>","ref":"VikWeb.CoreComponents.html#flash/1-examples"},{"type":"function","title":"Attributes - VikWeb.CoreComponents.flash/1","doc":"* `id` (`:string`) - the optional id of flash container.\n* `flash` (`:map`) - the map of flash messages to display. Defaults to `%{}`.\n* `title` (`:string`) - Defaults to `nil`.\n* `kind` (`:atom`) - used for styling and flash lookup.Must be one of `:info`, or `:error`.\n* Global attributes are accepted. the arbitrary HTML attributes to add to the flash container.","ref":"VikWeb.CoreComponents.html#flash/1-attributes"},{"type":"function","title":"Slots - VikWeb.CoreComponents.flash/1","doc":"* `inner_block` - the optional inner block that renders the flash message.","ref":"VikWeb.CoreComponents.html#flash/1-slots"},{"type":"function","title":"VikWeb.CoreComponents.flash_group/1","doc":"Shows the flash group with standard titles and content.","ref":"VikWeb.CoreComponents.html#flash_group/1"},{"type":"function","title":"Examples - VikWeb.CoreComponents.flash_group/1","doc":"<.flash_group flash={@flash} />","ref":"VikWeb.CoreComponents.html#flash_group/1-examples"},{"type":"function","title":"Attributes - VikWeb.CoreComponents.flash_group/1","doc":"* `flash` (`:map`) (required) - the map of flash messages.\n* `id` (`:string`) - the optional id of flash container. Defaults to `\"flash-group\"`.","ref":"VikWeb.CoreComponents.html#flash_group/1-attributes"},{"type":"function","title":"VikWeb.CoreComponents.header/1","doc":"Renders a header with title.","ref":"VikWeb.CoreComponents.html#header/1"},{"type":"function","title":"Attributes - VikWeb.CoreComponents.header/1","doc":"* `class` (`:string`) - Defaults to `nil`.","ref":"VikWeb.CoreComponents.html#header/1-attributes"},{"type":"function","title":"Slots - VikWeb.CoreComponents.header/1","doc":"* `inner_block` (required)\n* `subtitle`\n* `actions`","ref":"VikWeb.CoreComponents.html#header/1-slots"},{"type":"function","title":"VikWeb.CoreComponents.hide/2","doc":"Same as `Phoenix.LiveView.JS.hide/2`, but with an animation.","ref":"VikWeb.CoreComponents.html#hide/2"},{"type":"function","title":"VikWeb.CoreComponents.hide_modal/2","doc":"Hides a `modal/1`.","ref":"VikWeb.CoreComponents.html#hide_modal/2"},{"type":"function","title":"VikWeb.CoreComponents.icon/1","doc":"Renders a [Heroicon](https://heroicons.com).\n\nHeroicons come in three styles – outline, solid, and mini.\nBy default, the outline style is used, but solid and mini may\nbe applied by using the `-solid` and `-mini` suffix.\n\nYou can customize the size and colors of the icons by setting\nwidth, height, and background color classes.","ref":"VikWeb.CoreComponents.html#icon/1"},{"type":"function","title":"Examples - VikWeb.CoreComponents.icon/1","doc":"<.icon name=\"hero-x-mark-solid\" />\n    <.icon name=\"hero-arrow-path\" class=\"ml-1 w-3 h-3 animate-spin\" />","ref":"VikWeb.CoreComponents.html#icon/1-examples"},{"type":"function","title":"Attributes - VikWeb.CoreComponents.icon/1","doc":"* `name` (`:string`) (required)\n* `class` (`:string`) - Defaults to `nil`.","ref":"VikWeb.CoreComponents.html#icon/1-attributes"},{"type":"function","title":"VikWeb.CoreComponents.input/1","doc":"Renders an input with label and error messages.\n\nA `Phoenix.HTML.FormField` may be passed as argument,\nwhich is used to retrieve the input name, id, and values.\nOtherwise all attributes may be passed explicitly.","ref":"VikWeb.CoreComponents.html#input/1"},{"type":"function","title":"Types - VikWeb.CoreComponents.input/1","doc":"This function accepts all HTML input types, considering that:\n\n  * You may also set `type=\"select\"` to render a ` ` tag\n\n  * `type=\"checkbox\"` is used exclusively to render boolean values\n\n  * For live file uploads, see `Phoenix.Component.live_file_input/1`\n\nSee https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input\nfor more information. Unsupported types, such as hidden and radio,\nare best written directly in your templates.","ref":"VikWeb.CoreComponents.html#input/1-types"},{"type":"function","title":"Examples - VikWeb.CoreComponents.input/1","doc":"<.input field={@form[:email]} type=\"email\" />\n    <.input name=\"my-input\" errors={[\"oh no!\"]} />","ref":"VikWeb.CoreComponents.html#input/1-examples"},{"type":"function","title":"Attributes - VikWeb.CoreComponents.input/1","doc":"* `id` (`:any`) - Defaults to `nil`.\n* `name` (`:any`)\n* `label` (`:string`) - Defaults to `nil`.\n* `value` (`:any`)\n* `type` (`:string`) - Defaults to `\"text\"`.\n* `field` (`Phoenix.HTML.FormField`) - a form field struct retrieved from the form, for example: @form[:email].\n* `errors` (`:list`) - Defaults to `[]`.\n* `checked` (`:boolean`) - the checked flag for checkbox inputs.\n* `prompt` (`:string`) - the prompt for select inputs. Defaults to `nil`.\n* `options` (`:list`) - the options to pass to Phoenix.HTML.Form.options_for_select/2.\n* `multiple` (`:boolean`) - the multiple flag for select inputs. Defaults to `false`.\n* Global attributes are accepted. Supports all globals plus: `[\"accept\", \"autocomplete\", \"capture\", \"cols\", \"disabled\", \"form\", \"list\", \"max\", \"maxlength\", \"min\", \"minlength\", \"multiple\", \"pattern\", \"placeholder\", \"readonly\", \"required\", \"rows\", \"size\", \"step\"]`.","ref":"VikWeb.CoreComponents.html#input/1-attributes"},{"type":"function","title":"VikWeb.CoreComponents.label/1","doc":"Renders a label.","ref":"VikWeb.CoreComponents.html#label/1"},{"type":"function","title":"Attributes - VikWeb.CoreComponents.label/1","doc":"* `for` (`:string`) - Defaults to `nil`.","ref":"VikWeb.CoreComponents.html#label/1-attributes"},{"type":"function","title":"Slots - VikWeb.CoreComponents.label/1","doc":"* `inner_block` (required)","ref":"VikWeb.CoreComponents.html#label/1-slots"},{"type":"function","title":"VikWeb.CoreComponents.list/1","doc":"Renders a data list.","ref":"VikWeb.CoreComponents.html#list/1"},{"type":"function","title":"Examples - VikWeb.CoreComponents.list/1","doc":"<.list>\n      <:item title=\"Title\">{@post.title}</:item>\n      <:item title=\"Views\">{@post.views}</:item>\n    </.list>","ref":"VikWeb.CoreComponents.html#list/1-examples"},{"type":"function","title":"Slots - VikWeb.CoreComponents.list/1","doc":"* `item` (required) - Accepts attributes:\n\n  * `title` (`:string`) (required)","ref":"VikWeb.CoreComponents.html#list/1-slots"},{"type":"function","title":"VikWeb.CoreComponents.modal/1","doc":"Renders a modal.","ref":"VikWeb.CoreComponents.html#modal/1"},{"type":"function","title":"Examples - VikWeb.CoreComponents.modal/1","doc":"<.modal id=\"confirm-modal\">\n      This is a modal.\n    </.modal>\n\nJS commands may be passed to the `:on_cancel` to configure\nthe closing/cancel event, for example:\n\n    <.modal id=\"confirm\" on_cancel={JS.navigate(~p\"/posts\")}>\n      This is another modal.\n    </.modal>","ref":"VikWeb.CoreComponents.html#modal/1-examples"},{"type":"function","title":"Attributes - VikWeb.CoreComponents.modal/1","doc":"* `id` (`:string`) (required)\n* `show` (`:boolean`) - Defaults to `false`.\n* `on_cancel` (`Phoenix.LiveView.JS`) - Defaults to `%Phoenix.LiveView.JS{ops: []}`.","ref":"VikWeb.CoreComponents.html#modal/1-attributes"},{"type":"function","title":"Slots - VikWeb.CoreComponents.modal/1","doc":"* `inner_block` (required)","ref":"VikWeb.CoreComponents.html#modal/1-slots"},{"type":"function","title":"VikWeb.CoreComponents.show/2","doc":"Same as `Phoenix.LiveView.JS.show/2`, but with an animation.","ref":"VikWeb.CoreComponents.html#show/2"},{"type":"function","title":"VikWeb.CoreComponents.show_modal/2","doc":"Shows a `modal/1`.","ref":"VikWeb.CoreComponents.html#show_modal/2"},{"type":"function","title":"VikWeb.CoreComponents.simple_form/1","doc":"Renders a simple form.","ref":"VikWeb.CoreComponents.html#simple_form/1"},{"type":"function","title":"Examples - VikWeb.CoreComponents.simple_form/1","doc":"<.simple_form for={@form} phx-change=\"validate\" phx-submit=\"save\">\n      <.input field={@form[:email]} label=\"Email\"/>\n      <.input field={@form[:username]} label=\"Username\" />\n      <:actions>\n        <.button>Save</.button>\n      </:actions>\n    </.simple_form>","ref":"VikWeb.CoreComponents.html#simple_form/1-examples"},{"type":"function","title":"Attributes - VikWeb.CoreComponents.simple_form/1","doc":"* `for` (`:any`) (required) - the data structure for the form.\n* `as` (`:any`) - the server side parameter to collect all input under. Defaults to `nil`.\n* Global attributes are accepted. the arbitrary HTML attributes to apply to the form tag. Supports all globals plus: `[\"autocomplete\", \"name\", \"rel\", \"action\", \"enctype\", \"method\", \"novalidate\", \"target\", \"multipart\"]`.","ref":"VikWeb.CoreComponents.html#simple_form/1-attributes"},{"type":"function","title":"Slots - VikWeb.CoreComponents.simple_form/1","doc":"* `inner_block` (required)\n* `actions` - the slot for form actions, such as a submit button.","ref":"VikWeb.CoreComponents.html#simple_form/1-slots"},{"type":"function","title":"VikWeb.CoreComponents.table/1","doc":"Renders a table with generic styling.","ref":"VikWeb.CoreComponents.html#table/1"},{"type":"function","title":"Examples - VikWeb.CoreComponents.table/1","doc":"<.table id=\"users\" rows={@users}>\n      <:col :let={user} label=\"id\">{user.id}</:col>\n      <:col :let={user} label=\"username\">{user.username}</:col>\n    </.table>","ref":"VikWeb.CoreComponents.html#table/1-examples"},{"type":"function","title":"Attributes - VikWeb.CoreComponents.table/1","doc":"* `id` (`:string`) (required)\n* `rows` (`:list`) (required)\n* `row_id` (`:any`) - the function for generating the row id. Defaults to `nil`.\n* `row_click` (`:any`) - the function for handling phx-click on each row. Defaults to `nil`.\n* `row_item` (`:any`) - the function for mapping each row before calling the :col and :action slots. Defaults to `&Function.identity/1`.","ref":"VikWeb.CoreComponents.html#table/1-attributes"},{"type":"function","title":"Slots - VikWeb.CoreComponents.table/1","doc":"* `col` (required) - Accepts attributes:\n\n  * `label` (`:string`)\n* `action` - the slot for showing user actions in the last table column.","ref":"VikWeb.CoreComponents.html#table/1-slots"},{"type":"exception","title":"Vik.ShardNotAlive","doc":"Raised when a `Vik.Shard` is being accessed via HTTP, and\nit's available in the database, but not (yet) compiled.\n\nThis occurs when the Shard cannot compile and the app restarts,\nthereby deleting the stale module from runtime.","ref":"Vik.ShardNotAlive.html"},{"type":"exception","title":"Vik.ShardNotExposed","doc":"Raised when a `Vik.Shard` is being accessed via HTTP, but\nit does not `Vik.expose/1` any plug.","ref":"Vik.ShardNotExposed.html"},{"type":"exception","title":"Vik.ShardNotFound","doc":"Raised when a `Vik.Shard` cannot be found in the database.","ref":"Vik.ShardNotFound.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}